#!/usr/bin/perl -w
use strict;

my $LOGDIR  = "/var/log/shingetsu";
my $DATADIR = "/srv/shingetsu/dat";

sub date() {
	my @buf = localtime();
	return sprintf "%d-%02d-%02d",
		       1900+$buf[5], $buf[4]+1, $buf[3];
}
sub xlocaltime($) {
	my @buf = localtime($_[0]);
	return sprintf "%d-%02d-%02d %02d:%02d:%02d",
		       1900+$buf[5], $buf[4]+1, $buf[3], $buf[2], $buf[1], $buf[0];
}
sub escape($) {
	local($_) = @_;
	s/&/&amp;/g;
	s/&amp;(#\d+|#[Xx][0-9A-Fa-f]+|[A-Za-z0-9]+);/&$1;/g;
	s/</&lt;/g;
	s/>/&gt;/g;
	s/\r//g;
	s/\n/<br>/g;
	return $_;
}
sub str_encode($) {		# Thanks for YukiWiki & WalWiki
	my($s) = @_;
	$s =~ s|[^\w]|'%' . uc(unpack('H2', $&))|eg;
	return $s;
}

sub file_decode($) {		# Thanks for YukiWiki
	my($name) = @_;
	@_ = split /_/, $name, 2;
	$name = $_[1];
	$name =~ s/[0-9A-F][0-9A-F]/pack("C", hex($&))/eg;
	return escape($name);
}

my %check = ();
print "<html><head><title>update</title></head><body><ul>\n";
open IN, "$LOGDIR/" . date() or die;
while (<IN>) {
	chomp;
	@_ = split /<>/;
	if ((@_ > 3) && ($_[2] =~ /server.cgi.update/)) {
		my $buf = $';
		$buf =~ s/ .*//;
		my($null, $type, $title, $stamp, $id) = split /[\/_]/, $buf;
		unless ($check{"$type,$title,$stamp,$id"}) {
			$check{"$type,$title,$stamp,$id"} = 1;
			my $flag = (-e "$DATADIR/${type}_$title.dat")? "o": "x";
			my $str_title = file_decode("${type}_$title");
			print "  <li>", xlocaltime($stamp), " $flag ",
			      "<a href='http://localhost:8000/$type.cgi/",
			      str_encode($str_title),
			      "#r", substr($id, 0, 8), "'>",
			      $str_title, "</a></li>\n";
			warn xlocaltime($stamp), "\n";
		}
	}
}
close IN;
print "</ul></body></html>\n";
