#!/usr/bin/perl -w
#

$LIST = "/srv/shingetsu/dat/update.txt";

sub xlocaltime($) {
	my @buf = localtime($_[0]);
	return sprintf "%d-%02d-%02d %02d:%02d",
		       1900+$buf[5], $buf[4]+1, $buf[3], $buf[2], $buf[1];
}
sub file_decode($) {
	my($name) = @_;
	@_ = split /_/, $name, 2;
	$name = $_[1];
	$name =~ s/[0-9A-F][0-9A-F]/pack("C", hex($&))/eg;
	return $name;
}
sub str_encode($) {
	my ($s) = @_;
	my $encoded = '';
	foreach my $ch (split(//, $s)) {
		if ($ch =~ /[A-Za-z0-9_.\/#]/) {
			$encoded .= $ch;
		} else {
			$encoded .= '%' . sprintf("%02X", ord($ch));
		}
	}
	return $encoded;
}

if (@ARGV) {
	$host = $ARGV[0];
}

open IN, $LIST or exit;
open OUT, "| nkf -e";
select OUT;
print "<HTML><BODY><UL>\n";
while (<IN>) {
	chomp;
	@_ = split /<>/;
	$id = substr $_[1], 0, 8;
	$stamp = xlocaltime($_[0]);
	$name = $_[2];
	if ($name =~ /^(list|thread|note)_/) {
		$type = $1;
		$name = file_decode($name);
		$str  = str_encode($name);
		$uri  = "http://127.0.0.1:8000/$type.cgi/$str#r$id";
	} elsif ($host) {
		$uri  = "http://$host/gateway.cgi/THREAD/$name#r$id";
	} else {
		$uri  = "http://127.0.0.1:8000/tradgw.cgi/THREAD/$name#r$id";
	}
	$e = (-s "/srv/shingetsu/dat/$_[2].dat")? "o": "x";
	print "<LI>$stamp $e <A href='$uri'>$name</A>\n";
}
print "</UL></BODY></HTML>\n";
close IN;
close OUT;
